import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class GalCrash extends Applet implements ActionListener, ItemListener, AdjustmentListener{

   GalImage gi;
   GraphCanvas gc;
   Choice npart;

   public void init() {

      setLayout(new BorderLayout());
      TextField peri = new TextField();
      peri.setBackground(Color.white);
      peri.setForeground(Color.black);
      peri.setEditable(true);
      TextField cmass = new TextField();
      cmass.setBackground(Color.white);
      cmass.setForeground(Color.black);
      cmass.setEditable(true);
      TextField galtheta = new TextField();
      galtheta.setBackground(Color.white);
      galtheta.setForeground(Color.black);
      galtheta.setEditable(true);
      TextField galphi = new TextField();
      galphi.setBackground(Color.white);
      galphi.setForeground(Color.black);
      galphi.setEditable(true);
      TextField comptheta = new TextField();
      comptheta.setBackground(Color.white);
      comptheta.setForeground(Color.black);
      comptheta.setEditable(true);
      TextField compphi = new TextField();
      compphi.setBackground(Color.white);
      compphi.setForeground(Color.black);
      compphi.setEditable(true);
      npart = new Choice();
      npart.add("250");
      npart.add("500");
      npart.add("750");
      npart.add("1000");
      npart.add("1500");
      npart.add("2000");

      gc = new GraphCanvas(640, 100);

      Image title = getImage(getCodeBase(), "titlesm.jpg");

      gi = new GalImage(peri, cmass, galtheta, galphi, 
                        comptheta, compphi, npart, gc, title);
      gi.setBackground(Color.black);

      peri.addActionListener(this);
      cmass.addActionListener(this);
      galtheta.addActionListener(this);
      galphi.addActionListener(this);

      comptheta.addActionListener(this);
      compphi.addActionListener(this);
      npart.addItemListener(this);

      Button start = new Button("Start");
      start.addActionListener(this);
      Button stop = new Button("Stop");
      stop.addActionListener(this);
      Button reset = new Button("Reset");
      reset.addActionListener(this);

      Dial redtheta = new Dial(-180, 180, 0, 5, "Red Theta", "Degrees");
      Dial redphi = new Dial(-180, 180, 0, 5, "Red Phi", "Degrees");
      Dial greentheta = new Dial(-180, 180, 0, 5, "Green Theta", "Degrees");
      Dial greenphi = new Dial(-180, 180, 0, 5, "Green Phi", "Degrees");
      redtheta.setBackground(new Color(255, 150, 150));
      redphi.setBackground(new Color(255, 150, 150));
      greentheta.setBackground(new Color(150, 255, 150));
      greenphi.setBackground(new Color(150, 255, 150));
      redtheta.addAdjustmentListener(this);
      redphi.addAdjustmentListener(this);
      greentheta.addAdjustmentListener(this);
      greenphi.addAdjustmentListener(this);

      Checkbox zoom = new Checkbox("Green Centered");
      zoom.addItemListener(this);
      Checkbox fric = new Checkbox("Friction");
      fric.addItemListener(this);
      Checkbox bighalos = new Checkbox("Big Halos");
      bighalos.addItemListener(this);

      Panel top_panel = new Panel(new BorderLayout());
      Panel left_panel = new Panel(new BorderLayout());
      Panel dial_panel = new Panel(new GridLayout(2, 2));
      Panel control_panel = new Panel(new GridLayout(6, 2));

      control_panel.setBackground(new Color(150, 150, 255));
      control_panel.add(new Label("Peri [kpc]"));
      control_panel.add(peri);
      control_panel.add(new Label("Red Galaxy Mass"));
      control_panel.add(cmass);
      control_panel.add(new Label("Number of Stars"));
      control_panel.add(npart);
      control_panel.add(zoom);
      control_panel.add(start);
      control_panel.add(fric);
      control_panel.add(stop);
      control_panel.add(bighalos);
      control_panel.add(reset);


      dial_panel.add(redtheta);
      dial_panel.add(greentheta);
      dial_panel.add(redphi);
      dial_panel.add(greenphi);

      left_panel.add("North", dial_panel);
      left_panel.add("Center", control_panel);

      top_panel.add("East", gi);
      top_panel.add("Center", left_panel);

      add("South", gc);
      add("Center", top_panel);

   }

    public void actionPerformed(ActionEvent e){

       if(e.getActionCommand().equals("Start")){
          gi.go(true);
       }
       else if(e.getActionCommand().equals("Stop")){  
          gi.go(false);
       }
       else if(e.getActionCommand().equals("Reset")){  
	   gc.reset();
           gi.paramSwitch();
       }
       else {
          gi.paramSwitch();
       }

    }//actionPerformed

    public void itemStateChanged(ItemEvent e) {
       if (e.getItem().equals("Green Centered")) {
         gi.setZoom(((Checkbox)e.getItemSelectable()).getState());
       }
       else if (e.getItem().equals("Friction")) {
         gi.setFric(((Checkbox)e.getItemSelectable()).getState());
       }
       else if(e.getSource().equals(npart)){
	   gc.reset();
           gi.paramSwitch();
       }
       else if (e.getItem().equals("Big Halos")) {
         gi.setBigHalos(((Checkbox)e.getItemSelectable()).getState());
       }
       else {
         gi.paramSwitch();
       }
    }

    public void adjustmentValueChanged(AdjustmentEvent e){

        String source = e.getSource().toString();
	if(source.equals("Red Theta"))
	    gi.setCtheta((int)(e.getValue()/100.0));
	else if(source.equals("Red Phi"))
	    gi.setCphi((int)(e.getValue()/100.0));
	else if(source.equals("Green Theta"))
	    gi.setGtheta((int)(e.getValue()/100.0));
	else if(source.equals("Green Phi"))
	    gi.setGphi((int)(e.getValue()/100.0));

    }//adjustmentValueChanged

}
