//CHANGED 11-3-99 by Bob. Add ability to rotate viewpoint.

import java.awt.event.*;
import java.awt.*;

public class GalImage extends Canvas implements MouseListener, MouseMotionListener, Runnable {

/*
*********************************************************
CLASS VARIABLES
*********************************************************
*/

   final int SIZE = 400;
   final double dtime = 0.04;
   int nstargal=125;
   int nstarcomp=125;
   int nstartot=nstargal+nstarcomp;
   final double tperi=15;
   double dist,vel;
   double time=-0.04;
   double rperi=3.0;
   double galmass=4.8;
   double galahalo=0.1;
   double galvhalo=1.0;
   double galrthalo=5.0;
   double galdiskSize=2.5;
   double compmassrat=1.0;
   double compmass=4.8;
   double compahalo=0.1;
   double compvhalo=1.0;
   double comprthalo=5.0;
   double compdiskSize=2.5;
   double galtheta=0;
   double galphi=0;
   double comptheta=0;
   double compphi=0;
   double newperi,newcmass,newgtheta,newgphi,newctheta,newcphi;
   int galsx,galsy,compsx,compsy;
   int starsx[] = new int[2000];
   int starsy[] = new int[2000];
   double xc, yc, zc, scale; //CHANGE 11-3-99 added zc
   boolean running;
   boolean zoom;
   boolean friction;
   boolean bigHalos = false;
   Thread crash_thread;
   TextField peri, cmass, gtheta, gphi, ctheta, cphi;
   Choice nstarnew;
   Triple comacc = new Triple();
   StarGalaxy gal = new StarGalaxy(galmass, galahalo, galvhalo, galrthalo, galdiskSize, galtheta, galphi, nstargal);
   StarGalaxy comp = new StarGalaxy(compmass, compahalo, compvhalo, comprthalo, compdiskSize, comptheta, compphi, nstarcomp);
   Orbit crashOrbit = new Orbit(galmass, compmass, rperi, tperi);
   Graphics g;
   Image offImage,title;
   GraphCanvas gc;

/*
*********************************************************
CONSTRUCTOR
*********************************************************
*/

   GalImage(TextField pe, TextField cm, TextField gth, TextField gph,
            TextField cth, TextField cph, Choice nsn, GraphCanvas gc,
            Image intitle) {

      this.gc = gc;

      peri=pe;
      cmass=cm;
      gtheta=gth;
      gphi=gph;
      ctheta=cth;
      cphi=cph;
      nstarnew=nsn;
      title=intitle;

      addMouseListener(this);
      addMouseMotionListener(this);
      crash_thread = new Thread(this);

      gal.setPosvel(crashOrbit.bod1pos, crashOrbit.bod1vel);
      comp.setPosvel(crashOrbit.bod2pos, crashOrbit.bod2vel);
      peri.setText(Double.toString(round(3.5*rperi)));
      cmass.setText(Double.toString(round(compmassrat)));
      gtheta.setText(Double.toString(round(galtheta)));
      gphi.setText(Double.toString(round(galphi)));
      ctheta.setText(Double.toString(round(comptheta)));
      cphi.setText(Double.toString(round(compphi)));

   }

/*
*********************************************************
PAINT
*********************************************************
*/
    public void paint(Graphics g){

        update(g);

    }//paint

    public void update(Graphics h){

      if (g == null){
          offImage = createImage(SIZE, SIZE); 
          g = offImage.getGraphics();
	}//if

      int istar;

      if (time<0) {
          g.drawImage(title,0,100,this);
          g.setColor(Color.white);
          g.drawString("Concept: Chris Mihos",20,265);    
 	  g.drawString("Scientific Development: Chris Mihos, Greg Bothun",20,280);
	  g.drawString("Java programming: Chris Mihos, Dave Caley, Bob Vawter",20,295);
	  g.drawString("Web design: Cameron McBride, Chris Mihos",20,310);
          g.drawString("Hit Start, Stop, Reset to initialize...",20,350);
      } else {  
        g.setColor(Color.black);
        g.fillRect(0, 0, SIZE, SIZE);
        g.setColor(Color.green);
        g.fillOval(galsx-2, galsy-2, 5, 5);
        g.setColor(Color.red);
        g.fillOval(compsx-2, compsy-2, 5, 5);
        g.setColor(new Color(255, 150, 150));
        g.drawString("Galaxy Separation: "+Double.toString(round(dist))+" kpc",10,380);
        g.setColor(new Color(150, 150, 255));
	g.drawString("Relative Velocity: "+Double.toString(round(vel))+" km/s",225,380);
        g.setColor(Color.white);
        g.drawString("Elapsed Time: "+Double.toString(round(12.0*time))+" Myr",10,25);
        for (istar=0; istar<nstartot; istar++) {
          g.drawLine(starsx[istar],starsy[istar],starsx[istar],starsy[istar]);
        } //istar for loop

      }

      h.drawImage(offImage, 0, 0, this);

   }//update

/*
*********************************************************
RUN THREAD
*********************************************************
*/
   public void run() {

      int istar;

      while(running) {
         
         gal.galacc = comp.Acceleration(gal.galpos);
         comp.galacc = gal.Acceleration(comp.galpos);
	 dist=3.5*Triple.TripleMag(Triple.SubTriple(gal.galpos, comp.galpos));
         if (friction) { 
            gal.galacc = Triple.AddTriple(gal.galacc,
                                          comp.DynFric(gal.InteriorMass(dist/3.5),gal.galpos,gal.galvel));
            comp.galacc = Triple.AddTriple(comp.galacc,
                                           gal.DynFric(comp.InteriorMass(dist/3.5),comp.galpos,comp.galvel));
         }
         comacc.x=(gal.galmass*gal.galacc.x+
                   comp.galmass*comp.galacc.x)/(gal.galmass+comp.galmass);
         comacc.y=(gal.galmass*gal.galacc.y+
                   comp.galmass*comp.galacc.y)/(gal.galmass+comp.galmass);
         comacc.z=(gal.galmass*gal.galacc.z+
                   comp.galmass*comp.galacc.z)/(gal.galmass+comp.galmass);
         gal.galacc=Triple.SubTriple(gal.galacc,comacc);
         comp.galacc=Triple.SubTriple(comp.galacc,comacc);
         
         for (istar=0; istar<nstargal; istar++) {
             gal.stars[istar].acc = Triple.AddTriple(gal.Acceleration(gal.stars[istar].pos),
                                                    comp.Acceleration(gal.stars[istar].pos));
         }
         for (istar=0; istar<nstarcomp; istar++) {
            comp.stars[istar].acc = Triple.AddTriple(comp.Acceleration(comp.stars[istar].pos),
                                                    gal.Acceleration(comp.stars[istar].pos));
         } //istar for loop
         gal.MoveGalaxy(dtime);
         gal.MoveStars(dtime);
         comp.MoveGalaxy(dtime);
         comp.MoveStars(dtime);

	 dist=3.5*Triple.TripleMag(Triple.SubTriple(gal.galpos, comp.galpos));
	 vel =250.*Triple.TripleMag(Triple.SubTriple(gal.galvel, comp.galvel));

	 gc.addPoints(time*12, dist, time*12, vel);

//CHANGED 11-3 by Bob
         if (zoom) {
           xc=gal.galpos.x;
           yc=gal.galpos.y;
           zc=gal.galpos.z;
         } else {
           xc=0.0;
           yc=0.0;
           zc=0.0;
         }
	int holder[] = new int[3];

	//getFloats returns float[3] which is translated by matrix and returned in holder

	mat.transform(gal.galpos.getFloats((float)scale,xc,yc,zc),holder,1);
        galsx=(int)	(holder[0]+200);
        galsy=(int)	(200-holder[1]);

	mat.transform(comp.galpos.getFloats((float)scale,xc,yc,zc),holder,1);
        compsx=(int)	(holder[0]+200);
        compsy=(int)	(200-holder[1]);

	for (istar=0; istar<nstargal; istar++) {
	   mat.transform(gal.stars[istar].pos.getFloats((float)scale,xc,yc,zc),holder,1);
	   starsx[istar]=holder[0]+200;
	   starsy[istar]=200-holder[1];
	}

	for (istar=0; istar<nstargal; istar++) {
	   mat.transform(comp.stars[istar].pos.getFloats((float)scale,xc,yc,zc),holder,1);
	   starsx[istar+nstargal]=holder[0]+200;
	   starsy[istar+nstargal]=200-holder[1];
	}
//END CHANGES

         repaint();

	 time += dtime;

         try {
              crash_thread.sleep(10);
         } //try

         catch(InterruptedException e) {
            System.out.println(e.toString());
         } //catch

      }//while
   
   } //run

/*
*********************************************************
GO
*********************************************************
*/

   public void go(boolean b) {

      running=b;
      if(running) {
         crash_thread = new Thread(this);
         crash_thread.start();
      }
   } //go

/*
*********************************************************
ROUNDING METHOD
*********************************************************
*/
   public double round(double r) {
      r *= 10;
      r = Math.round(r);
      r /= 10;
      return r;
   } //round

/*
*********************************************************
setZOOM METHOD
*********************************************************
*/
   public void setZoom(boolean b) {
      if (b)
             zoom=true;
      else
             zoom=false;
   } //setRange

/*
*********************************************************
setBigHalos METHOD
*********************************************************
*/
   public void setBigHalos(boolean b) {
      if (b)
             bigHalos=true;
      else
             bigHalos=false;
      paramSwitch();
   } //setBigHalos

/*
*********************************************************
setFric METHOD
*********************************************************
*/
   public void setFric(boolean b) {
      if (b)
             friction=true;
      else
             friction=false;
      paramSwitch();
   } //setRange

/*

/*
*********************************************************
paramSwitch METHOD
*********************************************************
*/
   public void paramSwitch() {

      int istar,newstarnum;

      time=0;
      running=false;

      String holder=peri.getText();
      String holder2= new String();
      if (holder.endsWith("kpc")) {
        holder2=holder.substring(0,(holder.length()-4));
      } else {
        holder2=holder;
      }

      newperi=Double.valueOf(holder2).doubleValue(); 
      newcmass=Double.valueOf(cmass.getText()).doubleValue();
      newstarnum=Integer.valueOf(nstarnew.getSelectedItem()).intValue();

      /*
      newgtheta=Double.valueOf(gtheta.getText()).doubleValue();
      newgphi=Double.valueOf(gphi.getText()).doubleValue();
      newctheta=Double.valueOf(ctheta.getText()).doubleValue();
      newcphi=Double.valueOf(cphi.getText()).doubleValue();
      */

      nstargal=newstarnum/2;
      nstarcomp=newstarnum/2;
      nstartot=nstargal+nstarcomp;
      gal=null;
      comp=null;
      galmass=4.8;
      galrthalo=5.0;
      gal = new StarGalaxy(galmass, galahalo, galvhalo, galrthalo, galdiskSize, galtheta, galphi, nstargal);
      comp = new StarGalaxy(compmass, compahalo, compvhalo, comprthalo, compdiskSize, comptheta, compphi, nstarcomp);

      if (bigHalos) {
        galrthalo=20.0;
        galmass=Math.pow(galvhalo,2)*Math.pow(galrthalo,3)/
                Math.pow((galahalo+galrthalo),2);
        gal.rthalo=galrthalo;
        gal.galmass=galmass;
      }

      if (newperi != 0.0)
        rperi=Math.abs(newperi)/3.5;
      else
        rperi=0.001;
      peri.setText(Double.toString(round(rperi*3.5)));

      if (compmassrat != 0.0)
         compmassrat=Math.abs(newcmass);
      else
         compmassrat=0.001;
      cmass.setText(Double.toString(round(compmassrat)));
      compmass=galmass*compmassrat;
      comp.scaleMass(compmassrat);

      if (bigHalos) {
         comprthalo=comp.rthalo*4.0;
         compmass=Math.pow(compvhalo,2)*Math.pow(comprthalo,3)/
                Math.pow((compahalo+comprthalo),2);
         comp.rthalo=comprthalo;
         comp.galmass=compmass;
      }

      crashOrbit.updateOrbit(galmass, compmass, rperi, tperi);

      galtheta=newgtheta;
      gtheta.setText(Double.toString(round(galtheta)));
      galtheta=galtheta*(2.*Math.PI/360.);

      galphi=newgphi;
      gphi.setText(Double.toString(round(galphi)));
      galphi=galphi*(2.*Math.PI/360.);

      gal.setAngles(galtheta, galphi);

      comptheta=newctheta;
      ctheta.setText(Double.toString(round(comptheta)));
      comptheta=comptheta*(2.*Math.PI/360.);

      compphi=newcphi;
      cphi.setText(Double.toString(round(compphi)));
      compphi=compphi*(2.*Math.PI/360.);

      comp.setAngles(comptheta, compphi);


      nstargal=newstarnum/2;
      nstarcomp=newstarnum/2;
      nstartot=nstargal+nstarcomp;
      gal.setNumstars(nstargal);
      comp.setNumstars(nstarcomp);

      gal.setPosvel(crashOrbit.bod1pos, crashOrbit.bod1vel);
      gal.InitStars();
      comp.setPosvel(crashOrbit.bod2pos, crashOrbit.bod2vel);
      comp.InitStars();

      if (zoom) {
         xc=gal.galpos.x;
         yc=gal.galpos.y;
         scale=20.0;
      } else {
         xc=0.0;
         yc=0.0;
         scale=8.0;
      }
      galsx=(int) (scale*(gal.galpos.x-xc)+200.0);
      galsy=(int) (200.0-scale*(gal.galpos.y-yc));
      compsx=(int) (scale*(comp.galpos.x-xc)+200.0);
      compsy=(int) (200.0-scale*(comp.galpos.y-yc));

      for (istar=0; istar<nstargal; istar++) {
         starsx[istar]=(int) (scale*(gal.stars[istar].pos.x-xc)+200.0);
         starsy[istar]=(int) (200.0-scale*(gal.stars[istar].pos.y-yc));
      }
      for (istar=0; istar<nstarcomp; istar++) {
         starsx[istar+nstargal]=(int) (scale*(comp.stars[istar].pos.x-xc)+200.0);
         starsy[istar+nstargal]=(int) (200.0-scale*(comp.stars[istar].pos.y-yc));
      }
	mat.unit(); //CHANGE 11-3 by Bob
      repaint();

   }

    public void setGtheta(int i){

        newgtheta = i;
	if(!crash_thread.isAlive())
	    paramSwitch();

    }//setGtheta

    public void setGphi(int i){

        newgphi = i;
	if(!crash_thread.isAlive())
	    paramSwitch();

    }//setGtheta

    public void setCtheta(int i){

        newctheta = i;
	if(!crash_thread.isAlive())
	    paramSwitch();

    }//setCtheta

    public void setCphi(int i){

        newcphi = i;
	if(!crash_thread.isAlive())
	    paramSwitch();

    }//setCtheta

/*
*********************************************************
this is where the grab and twirl hooks will go
*********************************************************
*/
//CHANGED 11-3 by Bob
	int prevx, prevy;
	float xrot, yrot, zrot;
	Matrix3D mat = new Matrix3D();
	Matrix3D transmat = new Matrix3D();


   public void mouseClicked(MouseEvent e) {}
   public void mouseDragged(MouseEvent e) {
	int x = e.getX(); int y = e.getY();
     if (!(e.isShiftDown())) {
	transmat.unit(); //We create a translation matrix & apply it to main matrix
	xrot=(float)((prevy-y)*360.0f / getSize().width);
	yrot=(float)((x-prevx)*360.0f / getSize().height);
	transmat.xrot(xrot);
	transmat.yrot(yrot);
	mat.mult(transmat);
     }
     else if (e.isShiftDown()) {
		transmat.unit();
		zrot=(float)((prevx-x)*360.0/getSize().width);
		transmat.zrot(zrot);
		mat.mult(transmat);
		float zoomdelta=(float)((prevy-y)*64.0/getSize().height);
		scale+=zoomdelta;
		if (scale<4)
			scale=4;
		if (scale>40)
			scale=40;
     }

	if (!running){

           if (zoom) {
           	xc=gal.galpos.x;
           	yc=gal.galpos.y;
	   	zc=gal.galpos.z;
           } else {
           	xc=0.0;
           	yc=0.0;
	   	zc=0.0;
           }


		int holder[] = new int[3];
		mat.transform(gal.galpos.getFloats((float)scale,xc,yc,zc),holder,1);
		galsx=(int)	(holder[0]+200);
	        galsy=(int)	(200-holder[1]);

		mat.transform(comp.galpos.getFloats((float)scale,xc,yc,zc),holder,1);
	        compsx=(int)	(holder[0]+200);
	        compsy=(int)	(200-holder[1]);

		for (int istar=0; istar<nstargal; istar++) {
		   mat.transform(gal.stars[istar].pos.getFloats((float)scale,xc,yc,zc),holder,1);
		   starsx[istar]=holder[0]+200;
		   starsy[istar]=200-holder[1];
		}

		for (int istar=0; istar<nstargal; istar++) {
		   mat.transform(comp.stars[istar].pos.getFloats((float)scale,xc,yc,zc),holder,1);
		   starsx[istar+nstargal]=holder[0]+200;
		   starsy[istar+nstargal]=200-holder[1];
		}
		repaint();
	}

	prevx=x;prevy=y;
	e.consume();
	}
   public void mouseEntered(MouseEvent e) {}
   public void mouseExited(MouseEvent e) {}
   public void mousePressed(MouseEvent e) {prevx = e.getX(); prevy = e.getY(); e.consume();}
   public void mouseReleased(MouseEvent e) {}
   public void mouseMoved(MouseEvent e) {}
//END CHANGES
/*
*********************************************************
getPreferredSize Method
*********************************************************
*/
   public Dimension getPreferredSize() {
      return new Dimension(SIZE, SIZE);
   }//getPreferredSize

}
