public class Orbit {

/*
**********************************************************************
Class Variables
**********************************************************************
*/

   double energy;
   double rperi;
   double tperi;
   double eccentricity;
   double mass1,mass2;
   Triple bod1pos,bod2pos;
   Triple bod1vel,bod2vel;

/*
**********************************************************************
Constructor
**********************************************************************
*/

   Orbit(double m1, double m2, double rp, double tp) {

      energy=0.0;
      eccentricity=1.0;
      mass1=m1;
      mass2=m2;
      rperi=rp;
      tperi=tp;
      bod1pos = new Triple();
      bod1vel = new Triple();
      bod2pos = new Triple();
      bod2vel = new Triple();
      initOrbit(mass1, mass2, rperi, tperi);

   }

/*
**********************************************************************
updateOrbit
**********************************************************************
*/

   public void updateOrbit(double m1, double m2, double rp, double tp) {

      initOrbit(m1, m2, rp, tp);

   }

/* 
**********************************************************************
initOrbit   
**********************************************************************
*/

   public void initOrbit(double m1, double m2, double rp, double tp) {

   double mu,p,nhat,cots,s,cottheta,theta,tanfon2,sinsqphi;
   double r,vel,phi,f;
   double xc,yc,vxc,vyc,xcom,ycom,vxcom,vycom;

// Parabolic Orbit
      mu=m1+m2;
      p=2*rp;
      nhat=Math.sqrt(mu/p/p/p);
      cots=3.0*nhat*tp;
      s=Math.atan(1.0/cots);
      cottheta=Math.pow( (1./Math.tan(s/2.)), 0.3333);
      theta=Math.atan(1./cottheta);
      tanfon2=2./Math.tan(2.*theta);
      r=(p/2.)*(1+tanfon2*tanfon2);
      vel=Math.sqrt(2.*mu/r);
      sinsqphi=p/(2.*r);
      phi=Math.asin(Math.sqrt(sinsqphi));
      f=2.*Math.atan(tanfon2);
      xc=-r*Math.cos(f);
      yc= r*Math.sin(f);
      vxc= vel*Math.cos(f+phi);
      vyc=-vel*Math.sin(f+phi);
      xcom=m2*xc/(m1+m2);
      ycom=m2*yc/(m1+m2);
      vxcom=m2*vxc/(m1+m2);
      vycom=m2*vyc/(m1+m2);

      bod1pos.x=-xcom;
      bod1pos.y=-ycom;
      bod1pos.z=0.0;
      bod1vel.x=-vxcom;
      bod1vel.y=-vycom;
      bod1vel.z=0.0;
      bod2pos.x=xc-xcom;
      bod2pos.y=yc-ycom;
      bod2pos.z=0.0;
      bod2vel.x=vxc-vxcom;
      bod2vel.y=vyc-vycom;
      bod2vel.z=0.0;

   }

}
      
